<?php
include('config.php');
?>
<html>
<head>
</head>
<body style="text-align:center;">
<canvas id="pokedex" width="745" height="541">
</canvas>
<input autocomplete="off" style="position:absolute; top:-1000px;" type="text" id="url" autofocus="true" />
<script>
var currentTrainer = '<?php echo $trainerName; ?>';

String.prototype.capitalizeFirstLetter = function() {
    return this.charAt(0).toUpperCase() + this.slice(1);
}

function loadImage(path){
    return new Promise(function(resolve, reject){
        var img = new Image();
        img.onload = function(){
            resolve(img);
        }
        img.onerror = function(){
            reject();
        }
        img.src = path;
    });
}

function GET(path){
  return new Promise(function(resolve, reject){
    var xhr = new XMLHttpRequest();
    xhr.open('GET', encodeURI(path));
    xhr.onload = function() {
      if (xhr.status === 200) {
        try{
            var datas = JSON.parse(xhr.responseText);
            resolve(datas);
        }
        catch (err){
            reject('Invalid format');
        }
      }
      else{
        reject(xhr.statusText);
      }
    };
    xhr.send();
  });
}

function getMousePos(canvas, e) {

    /// getBoundingClientRect is supported in most browsers and gives you
    /// the absolute geometry of an element
    var rect = canvas.getBoundingClientRect();

    /// as mouse event coords are relative to document you need to
    /// subtract the element's left and top position:
    return {x: e.clientX - rect.left, y: e.clientY - rect.top};
}

var canvas = document.getElementById('pokedex');
var ctx = canvas.getContext('2d');

canvas.onclick = function(event){
    var pos = getMousePos(this, event);
    console.log(pos);
    if(pos.x > windowText.x){
        document.getElementById('url').focus();
    }
}

var actions = [{func: scanPokemon, url: 'ScanPokemon.php', title: 'Scan wild pokemon'}, {func: scanTrainer, url: 'ScanTrainer.php', title: 'Scan trainer'}, {func: askBadge, url: 'AskBadge.php', title: 'Ask for badge'}];
var currentAction = 0;
var pokemons = [];
var currentPokemon = 0;

var pokedexImg;
var windowText = {
    x:      456,
    y:      172,
    width:  680-456,
    height: 265-172
};

var windowPokemon = {
    x:      62,
    y:      158,
    width:  303-62,
    height: 312-158
};

loadImage('pokedex.gif').then(function(pokedexImgP){
    pokedexImg = pokedexImgP;
    drawPokedex(pokedexImg);
    drawActionTitle(actions[currentAction].title);
});

function drawPokedex(pokedexImg){
    ctx.drawImage(pokedexImg, 0, 0, canvas.width, canvas.height);
}

function drawActionTitle(action){
    ctx.save();
    ctx.fillStyle = '#30fb05';
    ctx.fillRect(windowText.x, windowText.y, windowText.width, windowText.height);

    ctx.textAlign = 'center';
    ctx.font = '1em DejaVu Sans';
    ctx.fillStyle = '#c72127';
    ctx.fillText(action, windowText.x+windowText.width/2, windowText.y+15);
    ctx.fillText('|', windowText.x+5, windowText.y+45);
    ctx.restore();
}

function drawUrl(value){
    ctx.save();

    ctx.fillStyle = '#30fb05';
    ctx.fillRect(windowText.x, windowText.y+20, windowText.width, windowText.height-20);

    ctx.font = '0.7em DejaVu Sans';
    ctx.fillStyle = '#c72127';
    ctx.fillText(value, windowText.x+5, windowText.y+45);

    ctx.restore();
}

function drawError(error){
    ctx.save();

    ctx.fillStyle = '#30fb05';
    ctx.fillRect(windowText.x, windowText.y+20, windowText.width, windowText.height-20);

    ctx.textAlign = 'center';
    ctx.font = '1.2em DejaVu Sans';
    ctx.fillStyle = '#c72127';
    ctx.fillText(error, windowText.x+windowText.width/2, windowText.y+85);

    ctx.restore();
}

function drawPokemon(pokemon){
    loadImage('data:image/gif;base64,'+pokemon.img).then(function(pokemonImg){
        ctx.save();
        ctx.clearRect(windowPokemon.x, windowPokemon.y, windowPokemon.width, windowPokemon.height+5);

        ctx.drawImage(pokemonImg, windowPokemon.x+pokemonImg.width/2+20, windowPokemon.y+pokemonImg.height/2, pokemonImg.width, pokemonImg.height);

        ctx.font = '1em DejaVu Sans';
        ctx.fillStyle = 'black';

        ctx.fillText('#'+pokemon.id+' '+pokemon.name.capitalizeFirstLetter(), windowPokemon.x+15, windowPokemon.y+35);

        ctx.fillText('Height : '+pokemon.height+' | Weight : '+pokemon.weight, windowPokemon.x+15, windowPokemon.y+55);
        ctx.textAlign = 'center';
        ctx.fillText('Type : '+pokemon.type, windowPokemon.x+windowPokemon.width/2, windowPokemon.y+windowPokemon.height);
        ctx.font = '0.9em DejaVu Sans';
        ctx.fillText(currentTrainer+'\'s pokemons', windowPokemon.x+windowPokemon.width/2, windowPokemon.y+10);
        ctx.restore();
    });
}

function drawBadge(content){
    ctx.save();
    ctx.clearRect(windowPokemon.x, windowPokemon.y, windowPokemon.width, windowPokemon.height+5);

    ctx.textAlign = 'center';
    ctx.font = '0.9em DejaVu Sans';
    ctx.fillText(content, windowPokemon.x+windowPokemon.width/2, windowPokemon.y+windowPokemon.height/2);
    ctx.restore();
}

function scanPokemon(result){
    drawActionTitle(actions[currentAction].title);
    if(typeof(result.error) === 'undefined'){
        drawPokemon(result);
    }
    else{
        drawError(result.error);
    }
}

function scanTrainer(result){
    drawActionTitle(actions[currentAction].title);
    pokemons = result.pokemons;
    currentPokemon = 0;
    drawPokemon(pokemons[currentPokemon]);
}

function askBadge(result){
    drawActionTitle(actions[currentAction].title);
    if(typeof(result.error) === 'undefined'){
        drawBadge(result);
    }
    else{
        drawError(result.error);
    }
}

document.getElementById('url').onkeyup = function(event){
    console.log(event.keyIdentifier);
    if(event.keyIdentifier !== 'Left' && event.keyIdentifier !== 'Right' && event.keyIdentifier !== 'Enter' && event.keyIdentifier !== 'Up' && event.keyIdentifier !== 'Down'){
        drawUrl(document.getElementById('url').value);
    }
}

document.onkeydown = function(event){
    var action = false;
    var changePokemon = false;

    switch(event.keyCode){
		case 37:
            if(document.getElementById('url').value === ''){
                action = true;
                currentAction -= 1;
            }
            break;
		case 39:
            if(document.getElementById('url').value === ''){
                action = true;
                currentAction += 1;
            }
            break;
		case 38:
            if(pokemons.length > 0){
                changePokemon = true;
                currentPokemon -= 1;
            }
            break;
		case 40:
            if(pokemons.length > 0){
                changePokemon = true;
                currentPokemon += 1;
            }
            break;
		case 13:
            GET(actions[currentAction].url+'?value='+encodeURI(document.getElementById('url').value)).then(actions[currentAction].func, function(error){
                drawError(error);
            });
            document.getElementById('url').value = '';
            break;
        default:
            console.log(event.keyIdentifier);
    }
    if(action){
        if(currentAction >= actions.length){
            currentAction = 0;
        }
        if(currentAction < 0){
            currentAction = actions.length-1;
        }
        drawActionTitle(actions[currentAction].title);
    }
    if(changePokemon){
        if(currentPokemon >= pokemons.length){
            currentPokemon = 0;
        }
        if(currentPokemon < 0){
            currentPokemon = pokemons.length-1;
        }
        drawPokemon(pokemons[currentPokemon]);
    }
}
</script>
</body>
</html>
