<?php

/*
 * On the list_proposal page add a button "accept" or "refuse"
 * The admin verification code is required. If its wrong 3 times in a row, its sent by SMS to the admin
 */

print '<h2 class="center">'.listProposalWait.'</h2>';

$order = getGet('orderBy');

if(!is_null($order) && (in_array($order, array('author', 'link', 'date', 'status')) || preg_match("/^\d+/", $order))) {
	$order = removeAllSpaces($order);
} else {
	$order = 'status DESC, date';
}

$query = $db->prepare("
	SELECT author, link, date, status
	FROM facepalm_proposal
	ORDER BY ".$order." ASC LIMIT 20"
);

$query->execute();

print '<table class="liststatus centered center">';

$format = '<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>' . "\n";

$here = sprintf("/%s/admin", safeHTML($lang));

printf($format,
       '<a href="'.$here.'/orderBy-author"><strong>'.author.'</strong></a>',
       '<a href="'.$here.'/orderBy-link"><strong>'.link.'</strong></a>',
       '<a href="'.$here.'/orderBy-date"><strong>Date</strong></a>',
       '<a href="'.$here.'/orderBy-status"><strong>'.status.'</strong></a>',
       '<strong>'.edit.'</strong><br /><small>'.requireSecret.'</small>'
);

while ($row = $query->fetch(PDO::FETCH_ASSOC))
{
	printf($format,
	       safeHTML($row['author']),
	       sprintf('<a href="%s">'.link.'</a>', safeHTML($row['link'])),
	       safeHTML($row['date']),
	       constant($row['status']),
	       '<a href="#lazy"><img src="/images/accept.png" alt="Accept" style="border: 0px;"/></a> <a href="#lazy"><img src="/images/refuse.png" alt="Refuse" style="border: 0px"/></a>'
	);
}

print '</table><br />';

print '<div class="center">';
print '<h2>'.getChallengePassword.'</h2>';
print giveMeSpecialCode . '<br /><br />';

$secretCode = getPost('secret_code');

if (!is_null($secretCode) && checkToken('facepalm_anticsrf'))
{
		$query = $db->prepare("
				SELECT secret_code FROM facepalm_users
				WHERE ip=:ip
		");

		$query->bindParam(':ip', getIp(), PDO::PARAM_STR);
		$query->execute();

		$row = $query->fetch(PDO::FETCH_ASSOC);

		$txt = strcmp($secretCode, $row['secret_code']) ? sonIAmDisappoint : sprintf(wellDoneSon, FLAG);
		printf('<script>alert("%s");</script>', $txt);
}

print '<form method="post" action="">'."\n";
printf('<input type="hidden" name="facepalm_anticsrf" value="%s" />', getToken('facepalm_anticsrf'));
print '<table class="box centered">
			<tr><td><strong>'.secretCode.'</strong></td><td><input type="text" size="7" name="secret_code" /></td></tr>
			<tr><td colspan="2"><input type="submit" value="YEAH!" /></td></tr>
		</table>';
print '</form>';
print '</div>';

?>
