CREATE DATABASE facepalm;
USE facepalm;
CREATE USER facepalm@localhost IDENTIFIED BY 'FIXME';

CREATE TABLE `facepalm_gallery` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `author` varchar(42) COLLATE utf8_unicode_ci NOT NULL,
  `path` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `thumb_path` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `path` (`path`),
  UNIQUE KEY `thumb_path` (`thumb_path`)
) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `facepalm_proposal` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `author` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `link` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `status` enum('accepted','refused','failed','wait') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'wait',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ip` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `facepalm_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `password` varchar(132) COLLATE utf8_unicode_ci NOT NULL,
  `secret_code` varchar(10) COLLATE utf8_unicode_ci DEFAULT NULL,
  `ip` varchar(15) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `login` (`login`)
) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

GRANT SELECT ON facepalm.facepalm_gallery TO facepalm@localhost;
GRANT INSERT, SELECT ON facepalm.facepalm_proposal TO facepalm@localhost;
GRANT SELECT ON facepalm.facepalm_users TO facepalm@localhost;
