<?php

require_once dirname(__FILE__).'/../config.php';
require_once dirname(__FILE__).'/../includes/security/security.php';
require_once dirname(__FILE__).'/../includes/security/ids.php';

# Forbidden access if not via URLrewrite
checkRequestURI();

# Add a small IDS security, just in case ;)
idsCheckGET();

session_start();

$dsn = sprintf('mysql:dbname=%s;host=%s', $dbConfig['database'], $dbConfig['host']);

try {
	$db = new PDO($dsn, $dbConfig['user'], $dbConfig['pass']);
} catch (PDOException $e) {
	echo 'Connection failed: ' . $e->getMessage();
}

$lang = getGet('lang');

if (is_null($lang)) {
	$lang = 'en';
}

if ($lang == 'fr') {
	require_once dirname(__FILE__).'/../includes/lang/fr.php';
} else {
	require_once dirname(__FILE__).'/../includes/lang/en.php';
}

require_once dirname(__FILE__).'/../includes/header.php';
require_once dirname(__FILE__).'/../includes/main.php';
require_once dirname(__FILE__).'/../includes/footer.php';

?>
