package johndog;

import java.io.*;
import java.net.*;

import johndog.core.*;
import johndog.util.*;

class JohnDog {
	static final int PORT = 42017;
	static final int BACKLOG = 2;
	static final String HOST = "0.0.0.0";
	static final int MAX_RETRY = 3;
	
	public static void main(String args[]) {		
		for (int retry=0;retry<MAX_RETRY;retry++) {
			try {
				JDServer server = new JDServer(PORT, BACKLOG, HOST);
				retry=0;
				server.serverLoop();
			} catch (UnknownHostException uhe) {
				JDUtil.jdDebug("Could not resolve hostname: " + HOST);
			} catch (IOException ioe) {
				JDUtil.jdDebug("Unable to bind to " + HOST + ":" + String.valueOf(PORT));
			}
			try {
				Thread.currentThread().sleep(5000);
			} catch (InterruptedException iex) {}
		}
	}
	
}
