package johndog.core;

import java.util.*;

class JDHTTPAction {

	private Map<Integer, String> statusMap;
	private Map<Integer, String> contentMap;

	public JDHTTPAction() {
		statusMap = new HashMap<Integer, String>();
		contentMap = new HashMap<Integer, String>();
		
		statusMap.put(200, "OK");
		statusMap.put(400, "Bad Request");
		statusMap.put(403, "Forbidden");
		statusMap.put(404, "Not Found");
		statusMap.put(500, "Internal Server Error");
		statusMap.put(501, "Not Implemented");
		statusMap.put(503, "Service Unavailable");
		statusMap.put(505, "HTTP Version Not Supported");
		
		contentMap.put(200, null);
		contentMap.put(400, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>400 Bad Request</title></head><body><h1>400 Bad Request</h1>Your browser issued a bad request.</body></html>");
		contentMap.put(403, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>403 Forbidden</title></head><body><h1>403 Forbidden</h1>You don't have permission to access the requested resource on this server.</body></html>");
		contentMap.put(404, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>404 Not Found</title></head><body><h1>404 Not Found</h1>The requested URL was not found on this server.</body></html>");
		contentMap.put(500, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>500 Internal Server Error</title></head><body><h1>500 Internal Server Error</h1>An unexpected error occured while trying to access the requested resource.</body></html>");
		contentMap.put(501, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>501 Not Implemented</title></head><body><h1>501 Not Implemented</h1>The requested method is not supported by this server.</body></html>");
		contentMap.put(503, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>503 Service Unavailable</title></head><body><h1>503 Service Unavailable</h1>The resource you are trying to access is currently unavailable. Please try again later.</body></html>");
		contentMap.put(505, "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\"><title>505 HTTP Version Not Supported</title></head><body><h1>505 HTTP Version Not Supported</h1>This server does not support, or refuses to support, the HTTP protocol version that was used in the request message.</body></html>");
	}
	
	public String getStatus(int code) {
		return statusMap.get(code);
	}
	
	public String getContent(int code) {
		return contentMap.get(code);
	}

}
