package johndog.core;

import java.net.*;
import java.io.*;
import java.util.*;

import johndog.util.*;

public class JDServer {

	private ServerSocket ssocket;

	public JDServer(int port, int backlog, String host) throws UnknownHostException, IOException {
		this.ssocket = new ServerSocket(port, backlog, InetAddress.getByName(host));
		JDUtil.jdDebug("Server started on " + host + ":" + String.valueOf(port));
		
		Timer guardian = new Timer();
		guardian.schedule(new JDGuardianAngel(), 0, 60000);
	}
	
	public void serverLoop() {
		Socket client = null;
		try {
			while (true) {
				client = null;

				JDClassLoader jdcl = new JDClassLoader((URLClassLoader)this.getClass().getClassLoader()); // sandbox
				Class jdch = jdcl.loadClass("johndog.core.JDConnectionHandler");
				
				client = ssocket.accept();			
				JDUtil.jdDebug("New client: " + client.getInetAddress());
				jdch.getDeclaredConstructors()[0].newInstance(client);
			}
		} catch (IOException ioe) {
			JDUtil.jdDebug("Fatal error while accepting new client, terminating..");
		} catch (Exception ex) {
			JDUtil.jdDebug("Fatal error while initializing sandbox, terminating..");
		}
		try {
			if (client != null)
				client.close();
			this.ssocket.close();
		} catch (IOException ioe) { }
	}

}
